/*@java
 @Created by Dmitriy I. Suyasov
 @Date: 02.06.2005
 @Time: 15:42:58
 */
package dsuyasov.inetDoc.functionality;

import java.util.ArrayList;
import java.util.Map;

public class RuleElement {

        /*@
               XML -    
        */
        private static final char ONE_REQUIRED = '!';
        /*@
               XML -     
        */
        private static final char ONE_IMPLIED = '?';
        /*@
               XML -    0   
        */
        private static final char ZERO_OR_MORE = '*';
        /*@
               XML -      
        */
        private static final char ONE_OR_MORE = '+';
        /*@
             
        */
        private static final char BRACKET_OPEN = '(';
        /*@
             
        */
        private static final char BRACKET_CLOSE = ')';
        /*@
              
        */
        private static final char ELEMENT_SEPARATOR = ',';

        /*@
              - 
        */
        private static final String EX = "ex";

        /*@
              -    
        */
        public static final int TYPE_ONE = 0;
        /*@
              -      
        */
        public static final int TYPE_ONE_OR_MORE = 1;
        /*@
              -     
        */
        public static final int TYPE_CAN_ONE = 2;
        /*@
              -    0   
        */
        public static final int TYPE_ZERO_OR_MORE = 3;

        /*@
             
        */
        private ArrayList exception = new ArrayList();

        /*@
              
        */
        private int type;
        /*@
              
        */
        private ArrayList name = new ArrayList();

        /*@
            .  .
            @param str ,  
            @param definitions  
        */
        public RuleElement(String str, Map definitions) throws Exception {
            switch (str.charAt(0)) {
                case ONE_REQUIRED:
                    type = TYPE_ONE;
                    break;
                case ONE_IMPLIED:
                    type = TYPE_CAN_ONE;
                    break;
                case ZERO_OR_MORE:
                    type = TYPE_ZERO_OR_MORE;
                    break;
                case ONE_OR_MORE:
                    type = TYPE_ONE_OR_MORE;
                    break;
                default:
                    throw new Exception("Incorrect rule: !?*+ must lay in first position.");
            }
            String tmp = str.substring(1);

            int index = tmp.indexOf(ELEMENT_SEPARATOR);
            if (index == tmp.length()-1)
                throw new Exception("Separator shouldn't situate at the end of rule");
            String nameValue = "";
            while (index>0) {
                String newName = tmp.substring(0, index);
                tmp = tmp.substring(index+1);
                if (newName.indexOf(EX+BRACKET_OPEN) == 0) {
                    exception.add(new Boolean(true));
                    newName = newName.substring((EX+BRACKET_OPEN).length(), newName.indexOf(BRACKET_CLOSE));
                } else
                    exception.add(new Boolean(false));
                nameValue = (String) definitions.get(newName);
                if ((nameValue == null) || (nameValue.length()==0))
                    throw new Exception("Name \""+newName+"\" need of definition.");
                name.add(nameValue);
                index = tmp.indexOf(ELEMENT_SEPARATOR);
                if (index == tmp.length()-1)
                    throw new Exception("Separator shouldn't situate at the and of rule");
            }
            if (tmp.indexOf(EX+BRACKET_OPEN) == 0) {
                exception.add(new Boolean(true));
                tmp = tmp.substring((EX+BRACKET_OPEN).length(), tmp.indexOf(BRACKET_CLOSE));
            } else
                exception.add(new Boolean(false));
            nameValue = (String) definitions.get(tmp);
            if ((nameValue == null) || (nameValue.length()==0))
                throw new Exception("Name \""+tmp+"\" need of definition.");
            name.add(nameValue);
        }

        /*@
              
            @return  
        */
        public int getType() {
            return type;
        }

        /*@
            ,     
            @param index   
            @return     
        */
        public boolean isException(int index) {
            return ((Boolean) exception.get(index)).booleanValue();
        }

        /*@
              
            @param index   
            @return 
        */
        public String getName(int index) {
            return (String) name.get(index);
        }

        /*@
               
            @return   
        */
        public int getNameCount() {
            return name.size();
        }

        /*@
               
            @return   
        */
        public ArrayList getNames() {
            return name;
        }

        /*@
                
        */
        private ArrayList next = new ArrayList();
        /*@
                 
        */
        private ArrayList positions = new ArrayList();

        /*@
              
            @param index    
            @return  
        */
        public int lastSuccessed(int index) {
            return ((Integer) ((Object[]) next.get(index))[0]).intValue();
        }

        /*@
                 
            @param index    
            @return    
        */
        public RuleElement lastSuccessedLink(int index) {
            return ((RuleElement) ((Object[]) next.get(index))[1]);
        }
        /*@
             ,     
            @param index  
            @return 
        */
        public int position(int index) {
            return ((Integer) positions.get(index)).intValue();
        }

        /*@
                 
        */
        public void clearNextList() {
            next.clear();
            positions.clear();
        }

        /*@
             ,       ( ,       )
         @param str  
         @param next    
         @param nextLink     
         @return  ,     
         */
        public ArrayList satisfy(String str, Integer next, RuleElement nextLink) {
            ArrayList toReturn = new ArrayList();
            for (int index = 0; index < name.size(); index++) {
                String tmp = (String) name.get(index);
                if (tmp.length() > str.length())
                    continue;
                if (isException(index)) {
                    if (!str.substring(str.length() - tmp.length()).equals(tmp)) {
                        toReturn.add(new Integer(str.length() - tmp.length()));
                        this.next.add(new Object[] {next, nextLink});
                        positions.add(new Integer(str.length() - tmp.length()));
                    }
                } else {
                    if (str.substring(str.length() - tmp.length()).equals(tmp)) {
                        toReturn.add(new Integer(str.length() - tmp.length()));
                        this.next.add(new Object[] {next, nextLink});
                        positions.add(new Integer(str.length() - tmp.length()));
                    }
                }
            }
            return toReturn;
        }

    }
