/*@java
 @Created by Dmitriy I. Suyasov
 @Date 07.04.2005
 @Time 12:21:53
 */
package dsuyasov.inetDoc.automat;

import dsuyasov.inetDoc.functionality.Log;
import dsuyasov.inetDoc.main.InetDocConstant;
import dsuyasov.inetDoc.functionality.Template;
import dsuyasov.inetDoc.functionality.XMLProcessor;
import dsuyasov.inetDoc.functionality.CommonVariables;
import dsuyasov.inetDoc.main.InetDocError;
import dsuyasov.inetDoc.main.InetDocErrorConstant;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.io.*;
import java.text.MessageFormat;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;


public class AutomatMain extends Automat{

    /*@
         
     */
    private Automat automatDocumentator = null;

    /*@
        .
        @param automatNumber  
     */
    public AutomatMain(int automatNumber) {
        super(automatNumber);
    }

    /*@
       
     */
    protected void initialize() {
    }

    /*@
         
        @param event   
     */
    protected synchronized void automat(int event) {
        int y0_statePrevious = y_state;
        log.automatWork(" "+automatNumber+"     " + y_state, true);

        switch (y_state) {
            case (AutomatMainConstant.STATE_0_START_WORK):
                if (x0_errorFound()) {
                    y_state = AutomatMainConstant.STATE_7_END_WORK;
                    z3_logError();
                    log.automatChangeState(" "+automatNumber+"    0   7:   ");
                } else if (!x2_argumentListEmpty()) {
                    z1_processArgument();
                } else {
                    y_state = AutomatMainConstant.STATE_1_LOAD_PROPERTIES;
                    z5_setDefaultSettings();
                    log.automatChangeState(" "+automatNumber+"    0   1:  ");
                }
                break;
            case (AutomatMainConstant.STATE_1_LOAD_PROPERTIES):
                if (x0_errorFound()) {
                    y_state = AutomatMainConstant.STATE_7_END_WORK;
                    z3_logError();
                    log.automatChangeState(" "+automatNumber+"    1   7:   ");
                } else if (x1_enoughSettingsToStartWork()) {
                    y_state = AutomatMainConstant.STATE_2_PROCESS;
                    z7_getFilesList();
                    log.automatChangeState(" "+automatNumber+"    1   2:  ");
                } else {
                    y_state = AutomatMainConstant.STATE_7_END_WORK;
                        log.automatChangeState(" "+automatNumber+"    1   7:   ");
                }
                break;
            case (AutomatMainConstant.STATE_2_PROCESS):
                if (x0_errorFound()) {
                    y_state = AutomatMainConstant.STATE_7_END_WORK;
                    z3_logError();
                    log.automatChangeState(" "+automatNumber+"    2   7:   ");
                } else if (x3_newFileToDocumentExist()) {
                    if (x5_templateForNextFileExist()) {
                        y_state = AutomatMainConstant.STATE_3_PROCESS_FILE_AND_FILL_TEMPLATE;
                        z8_createPageDocumentatorAutomat();
                        log.automatChangeState(" "+automatNumber+"    2   3:  ");
                    } else {
                        y_state = AutomatMainConstant.STATE_4_FILL_TEMPLATE;
                        z12_createFillTemplateAutomat();
                        log.automatChangeState(" "+automatNumber+"    2   4:  ");
                    }
                } else {
                    y_state = AutomatMainConstant.STATE_5_CREATING_COMMON_FILES;
                    z10_initialiseCommonFilesCreation();
                    log.automatChangeState(" "+automatNumber+"    2   5:   ");
                }
                break;
            case (AutomatMainConstant.STATE_3_PROCESS_FILE_AND_FILL_TEMPLATE):
                if (x0_errorFound()) {
                    y_state = AutomatMainConstant.STATE_7_END_WORK;
                    z3_logError();
                    log.automatChangeState(" "+automatNumber+"    3   7:   ");
                } else {
                    y_state = AutomatMainConstant.STATE_2_PROCESS;
                    log.automatChangeState(" "+automatNumber+"    3   2:  ");
                }
                break;
            case (AutomatMainConstant.STATE_4_FILL_TEMPLATE):
                if (x0_errorFound()) {
                    y_state = AutomatMainConstant.STATE_7_END_WORK;
                    z3_logError();
                    log.automatChangeState(" "+automatNumber+"    4   7:   ");
                } else {
                    y_state = AutomatMainConstant.STATE_2_PROCESS;
                    z13_saveFillTemplateAutomatResult();
                    log.automatChangeState(" "+automatNumber+"    4   2:  ");
                }
                break;
            case (AutomatMainConstant.STATE_5_CREATING_COMMON_FILES):
                if (x0_errorFound()) {
                    y_state = AutomatMainConstant.STATE_7_END_WORK;
                    z3_logError();
                    log.automatChangeState(" "+automatNumber+"    5   7:   ");
                } else if (x4_haveUnprocessedCommonFile()) {
                    y_state = AutomatMainConstant.STATE_6_FILL_TEMPLATE_FOR_COMMON_FILE;
                    z9_createFillTemplateAutomatForCommonFile();
                    log.automatChangeState(" "+automatNumber+"    5   6:     ");
                } else {
                    y_state = AutomatMainConstant.STATE_7_END_WORK;
                    log.automatChangeState(" "+automatNumber+"    5   7:   ");
                }
                break;
            case (AutomatMainConstant.STATE_6_FILL_TEMPLATE_FOR_COMMON_FILE):
                if (x0_errorFound()) {
                    y_state = AutomatMainConstant.STATE_7_END_WORK;
                    z3_logError();
                    log.automatChangeState(" "+automatNumber+"    6   7:   ");
                } else {
                    y_state = AutomatMainConstant.STATE_5_CREATING_COMMON_FILES;
                    z11_saveAutomatResultToFile();
                    log.automatChangeState(" "+automatNumber+"    6   5:   ");break;
                }
        }

        if (y0_statePrevious != y_state)
            switch (y_state) {
                case (AutomatMainConstant.STATE_1_LOAD_PROPERTIES):
                    z2_loadProperties();
                    break;
                case (AutomatMainConstant.STATE_3_PROCESS_FILE_AND_FILL_TEMPLATE):
                    automatDocumentator.work();
                    break;
                case (AutomatMainConstant.STATE_4_FILL_TEMPLATE):
                    automatDocumentator.work();
                    break;
                case (AutomatMainConstant.STATE_6_FILL_TEMPLATE_FOR_COMMON_FILE):
                    automatDocumentator.work();
                    break;
                case (AutomatMainConstant.STATE_7_END_WORK):
                    z0_closeProgram();
                    break;
            }
        log.automatWork(" "+automatNumber+"     " + y_state, false);
    }

    // Input variables

    /*@
         
     @return    
     */
    private boolean x0_errorFound() {
        boolean value = false;
        for (int iLoop = 0; iLoop < CommonVariables.getInstance().errors.size(); iLoop++)
            if ((CommonVariables.getInstance().errors.get(iLoop) instanceof InetDocError) &&
                    (((InetDocError)CommonVariables.getInstance().errors.get(iLoop)).getType() == InetDocError.TYPE_ERROR))
                value = true;
        log.inputVariable("x0 -    ", value);
        return value;
    }

    /*@
              
        @return     
     */
    private boolean x1_enoughSettingsToStartWork() {
        CommonVariables cv = CommonVariables.getInstance();
        if (cv.sourceDirectory == null) {
            Log.getLogger().inputVariable("x1 -     ", false);
            return false;
        }
        log.inputVariable("x1 -     ", true);
        return true;
    }

    /*@
        ,     
        @return     
     */
    private boolean x2_argumentListEmpty() {
        boolean value = CommonVariables.getInstance().arguments.size() == 0;
        log.inputVariable("x2 -   ", value);
        return value;
    }

    /*@
           
        @return    
     */
    private boolean x3_newFileToDocumentExist() {
        CommonVariables cv = CommonVariables.getInstance();
        boolean value = cv.files.size() > cv.documentFiles;
        log.inputVariable("x3 -    ", value);
        return value;
    }

    /*@
            
        @return     
     */
    private boolean x4_haveUnprocessedCommonFile() {
        CommonVariables cv = CommonVariables.getInstance();
        boolean value = cv.commonFiles.size() > cv.documentFiles;
        log.inputVariable("x4 -     ", value);
        return value;
    }

    /*@
              
        @return      
     */
    private boolean x5_templateForNextFileExist() {
        CommonVariables cv = CommonVariables.getInstance();
        String pageFileName = (String) cv.files.get(cv.documentFiles);
        for (int iLoop = 0; iLoop < cv.templates.size(); iLoop++) {
            ArrayList types = ((Template) cv.templates.get(iLoop)).types;
            for (int iLoop2 = 0; iLoop2 < types.size(); iLoop2++)
                if (pageFileName.lastIndexOf((String) types.get(iLoop2)) == pageFileName.length() - ((String) types.get(iLoop2)).length()) {
                    log.inputVariable("x5 -  -   ", true);
                    return true;
                }
        }
        log.inputVariable("x5 -  -   ", true);
        return false;
    }

    //  

    /*@
          
     */
    private void z0_closeProgram() {
        log.output("z0 -   ");
        running = false;
    }

    /*@
           
     */
    private void z1_processArgument() {
        log.output("z1 -    ");
        CommonVariables cv = CommonVariables.getInstance();
        ArrayList arguments = cv.arguments;
        ArrayList errors = cv.errors;
        String arg1 = (String) arguments.get(0);
        String arg2 = null;
        if (arguments.size() >= 2)
            arg2 = (String) arguments.get(1);
        int argumentsToDel = 1;

        if (arg1.equals(InetDocConstant.ARGUMENT_HELP)) {
            Log.getLogger().out(InetDocConstant.EMPTY_PROGRAM_OUT);
        } else
        if (arg1.equals(InetDocConstant.ARGUMENT_CAN_LOG_TO_FILE)) {
            InetDocConstant.fileSaved = true;
        } else
        if (arg1.equals(InetDocConstant.ARGUMENT_CAN_LOG_TO_SCREEN)) {
            InetDocConstant.screenSaved = true;
        } else
        if (arg1.equals(InetDocConstant.ARGUMENT_LOG_FILE)) {
            if (arg2 != null) {
                log.killLog();
                InetDocConstant.LOG_FILE_NAME = arg2;
            } else
                errors.add(new InetDocError(InetDocError.TYPE_ERROR, InetDocErrorConstant.ERROR_LOG_FILE_UNDEFINED));
            argumentsToDel = 2;
        } else
        if (arg2 == null) {
            cv.sourceDirectory = arg1;
            File directory = new File(arg1);
            if (!directory.isDirectory())
                errors.add(new InetDocError(InetDocError.TYPE_ERROR, MessageFormat.format(InetDocErrorConstant.ERROR_WRONG_SOURCE_DIRECTORY, new String[] {arg1})));
            cv.sourceDirectory = directory.getAbsolutePath();
        } else
            errors.add(new InetDocError(InetDocError.TYPE_ERROR, MessageFormat.format(InetDocErrorConstant.ERROR_UNKNOWN_ARGUMENT, new String[] {arg1})));

        for (int iLoop = 0; iLoop < argumentsToDel; iLoop++)
            if (arguments.size()>0) arguments.remove(0);
    }


    /*@
            
     */
    private void z2_loadProperties() {
        log.output("z2 -      ");
        CommonVariables cv = CommonVariables.getInstance();
        try {
            DocumentBuilder db =  DocumentBuilderFactory.newInstance().newDocumentBuilder();
            Document doc = db.parse(InetDocConstant.PROPERTY_FILE_NAME);
            Node defnode = doc.getElementsByTagName("default").item(0);
            if (defnode == null)
                throw new Exception("  \"default\"   \""+InetDocConstant.PROPERTY_FILE_NAME+"\"");
            cv.defaultTemplate = defnode.getAttributes().getNamedItem("template").getNodeValue();
            if ((cv.defaultTemplate == null) || (cv.defaultTemplate.length()==0))
                throw new Exception("  \"default\"   \""+InetDocConstant.PROPERTY_FILE_NAME+"\"");
            cv.templates = new ArrayList();

            NodeList nodeList = doc.getElementsByTagName("common");
            for (int iLoop = 0; iLoop < nodeList.getLength(); iLoop++) {
                Node node = nodeList.item(iLoop);
                String name = node.getAttributes().getNamedItem("name").getNodeValue();
                if ((name==null) || (name.length()==0))
                    throw new Exception("Tag \"common\" should contain attribute \"name\".");
                String tmp = node.getAttributes().getNamedItem("template").getNodeValue();
                if ((tmp==null) || (tmp.length()==0))
                    throw new Exception("Tag \"common\" should contain attribute \"template\".");
                cv.commonFiles.add(new String[] {name, tmp});
            }

            nodeList = doc.getElementsByTagName("file");
            for (int iLoop = 0; iLoop < nodeList.getLength(); iLoop++) {
                ArrayList types = new ArrayList();
                int typeNumber = 1;
                Node node = XMLProcessor.getNode(nodeList.item(iLoop), "extension", typeNumber);
                while (node != null) {
                    types.add(node.getAttributes().getNamedItem("name").getNodeValue());
                    node = XMLProcessor.getNode(nodeList.item(iLoop), "extension", ++typeNumber);
                }
                if (types.size() == 0)
                    throw new Exception();
                try {
                    cv.templates.add(new Template(types, XMLProcessor.getNode(nodeList.item(iLoop), "template", 1).getAttributes().getNamedItem("href").getNodeValue()));
                } catch (Exception e) {
                    throw new Exception(e.getMessage());
                }
            }
        } catch (Exception pce) {
            cv.errors.add(new InetDocError(InetDocError.TYPE_ERROR, MessageFormat.format(InetDocErrorConstant.ERROR_PROCESS_PROPERTY + " " + pce.getMessage(), new String[] {InetDocConstant.PROPERTY_FILE_NAME})));
        }
    }

    /*@
                
     */
    private void z3_logError() {
        log.output("z3 -     ");
        ArrayList errors = CommonVariables.getInstance().errors;

        for (int iLoop = 0; iLoop < errors.size(); iLoop++) {
            if (errors.get(iLoop) instanceof InetDocError) {
                InetDocError error = (InetDocError) errors.get(iLoop);
                switch (error.getType()) {
                    case (InetDocError.TYPE_ERROR):
                        log.error(error.getMessage());
                        break;
                    case (InetDocError.TYPE_WARNING):
                        log.error(error.getMessage());
                        break;
                }
            } else log.error("Unknown error type: " + errors.get(iLoop));
        }
    }

    /*@
              
     */
    private void z5_setDefaultSettings() {
        log.output("z5 -     ");

        Log log = Log.getLogger();
        log.newLog();
        log.logToFile = InetDocConstant.fileSaved;
        log.logToScreen = InetDocConstant.screenSaved;
        if (log.logToFile) log.fileOut(log.buffer);
        if (log.logToScreen) log.out(log.buffer);
        InetDocConstant.bufferedSaved = false;
        log.buffer = "";
    }

    /*@
          ,  
     */
    private void z7_getFilesList() {
        log.output("z7 -     ");
        CommonVariables cv = CommonVariables.getInstance();
        cv.files = new ArrayList();

        try {
            cv.getAllFiles(cv.files, cv.sourceDirectory);
        } catch (Exception e) {
            cv.errors.add(new InetDocError(InetDocError.TYPE_ERROR, InetDocErrorConstant.ERROR_GET_FILE_NAMES));
        }
        cv.documentFiles = 0;
    }

    /*@
              
     */
    private void z8_createPageDocumentatorAutomat() {
        log.output("z8 -   -   ");
        CommonVariables cv = CommonVariables.getInstance();
        int templateNumber = 0;
        String pageFileName = (String) cv.files.get(cv.documentFiles);
        for (int iLoop = 0; iLoop < cv.templates.size(); iLoop++) {
           ArrayList types = ((Template) cv.templates.get(iLoop)).types;
           for (int iLoop2 = 0; iLoop2 < types.size(); iLoop2++)
               if (pageFileName.lastIndexOf((String) types.get(iLoop2)) == pageFileName.length() - ((String) types.get(iLoop2)).length())
                   templateNumber = iLoop;
        }
        automatDocumentator = new AutomatPageDocumentator(1, templateNumber, pageFileName);
        cv.documentFiles++;
    };

    /*@
              
     */
    private void z9_createFillTemplateAutomatForCommonFile() {
        log.output("z9 -       ");
        CommonVariables cv = CommonVariables.getInstance();

        String template = ((String[]) cv.commonFiles.get(cv.documentFiles))[1];
        File file = new File(template);

        String tmpText = "";
        FileReader fr;
        char charbuff[] = new char [(int) file.length()];
        try {
            fr = new FileReader(file);
            fr.read(charbuff);
            tmpText = new String(charbuff);
        } catch (FileNotFoundException fnfe) {
            CommonVariables.getInstance().errors.add(new InetDocError(InetDocError.TYPE_ERROR, MessageFormat.format(InetDocErrorConstant.ERROR_FILE_NOT_FOUND + " Stack trace: "+fnfe.getMessage(), new String[] {file.getAbsolutePath()})));
        } catch (IOException ioe) {
            CommonVariables.getInstance().errors.add(new InetDocError(InetDocError.TYPE_ERROR, MessageFormat.format(InetDocErrorConstant.ERROR_WHILE_READ_THE_FILE + " Stack trace: "+ioe.getMessage(), new String[] {file.getAbsolutePath()})));
        }
        automatDocumentator = new AutomatHTMLResolver(2, cv.commonMap, null, tmpText);
    }

    /*@
           
     */
    private void z10_initialiseCommonFilesCreation() {
        log.output("z10 -    ");
        CommonVariables.getInstance().documentFiles = 0;
    }

    /*@
                 
     */
    private void z11_saveAutomatResultToFile() {
        log.output("z11 -      ");
        CommonVariables cv = CommonVariables.getInstance();
        String name = ((String[]) cv.commonFiles.get(cv.documentFiles))[0];
        String fileText = (String) CommonVariables.getInstance().currentDocFile.pop();
        if (name.indexOf(File.separator) != 0)
            name = File.separator + name;
        name = InetDocConstant.DESTINATION_DIRECTORY + name;
        File file = new File(name);
        try {
            FileWriter fw = new FileWriter(file);
            fw.write(fileText);
            fw.close();
        }
        catch (Exception e) {
            CommonVariables.getInstance().errors.add(new InetDocError(InetDocError.TYPE_ERROR, MessageFormat.format(InetDocErrorConstant.ERROR_WHILE_WRITE_THE_FILE + " Stack trace: "+e.getMessage(), new String[] {file.getAbsolutePath()})));
        }
        cv.documentFiles++;
    }

    /*@
                   
     */
    private void z12_createFillTemplateAutomat() {
        log.output("z11 -       c  ");
        CommonVariables cv = CommonVariables.getInstance();

        //       
        Map map = new HashMap();
        String absoluteName = ((String) cv.files.get(cv.documentFiles)).substring(cv.sourceDirectory.length());
        map.put(AutomatPageDocumentator.TOMAP_ABSOLUTE_FILENAME, absoluteName);
        map.put(AutomatPageDocumentator.TOMAP_FILENAME, (absoluteName.indexOf(File.separator)>=0)?absoluteName.substring(absoluteName.lastIndexOf(File.separator)+1):absoluteName);
        map.put(AutomatPageDocumentator.TOMAP_DOCROOT, InetDocConstant.DESTINATION_DIRECTORY);
        map.put(AutomatPageDocumentator.TOMAP_SOURCEDIR, CommonVariables.getInstance().sourceDirectory);

        //   
        File file = new File(cv.defaultTemplate);
        String tmpText = "";
        FileReader fr;
        char charbuff[] = new char [(int) file.length()];
        try {
            fr = new FileReader(file);
            fr.read(charbuff);
            tmpText = new String(charbuff);
        } catch (FileNotFoundException fnfe) {
            CommonVariables.getInstance().errors.add(new InetDocError(InetDocError.TYPE_ERROR, MessageFormat.format(InetDocErrorConstant.ERROR_FILE_NOT_FOUND + " Stack trace: "+fnfe.getMessage(), new String[] {file.getAbsolutePath()})));
        } catch (IOException ioe) {
            CommonVariables.getInstance().errors.add(new InetDocError(InetDocError.TYPE_ERROR, MessageFormat.format(InetDocErrorConstant.ERROR_WHILE_READ_THE_FILE + " Stack trace: "+ioe.getMessage(), new String[] {file.getAbsolutePath()})));
        }

        //    
        automatDocumentator = new AutomatHTMLResolver(2, map, null, tmpText);
    }

    /*@
                
     */
    private void z13_saveFillTemplateAutomatResult() {
        log.output("z11 -      ");
        CommonVariables cv = CommonVariables.getInstance();

        //      
        String fileText = (String) CommonVariables.getInstance().currentDocFile.pop();
        String name = InetDocConstant.DESTINATION_DIRECTORY + ((String) cv.files.get(cv.documentFiles)).substring(cv.sourceDirectory.length()) + ".html";

        //  ,      
        String tmpStr = name;
        String directoryName = "";
        while (tmpStr.indexOf(File.separator) >= 0) {
            directoryName += (directoryName.length()>0)?File.separator:"";
            directoryName += tmpStr.substring(0, tmpStr.indexOf(File.separator));
            tmpStr = tmpStr.substring(tmpStr.indexOf(File.separator) + File.separator.length());
            File dir = new File(directoryName);
            dir.mkdir();
        }

        //   
        File file = new File(name);
        try {
            FileWriter fw = new FileWriter(file);
            fw.write(fileText);
            fw.close();
        }
        catch (Exception e) {
            CommonVariables.getInstance().errors.add(new InetDocError(InetDocError.TYPE_ERROR, MessageFormat.format(InetDocErrorConstant.ERROR_WHILE_WRITE_THE_FILE + " Stack trace: "+e.getMessage(), new String[] {file.getAbsolutePath()})));
        }

        //      -
        int index = 0;
        String res = (String) cv.commonMap.get(AutomatPageDocumentator.TOMAP_ABSOLUTE_FILENAME);
        while ((res!=null) && (res.length()>0))
            res = (String) cv.commonMap.get(AutomatPageDocumentator.TOMAP_ABSOLUTE_FILENAME+(++index));
        String absoluteName = ((String) cv.files.get(cv.documentFiles)).substring(cv.sourceDirectory.length()+1);
        cv.commonMap.put(AutomatPageDocumentator.TOMAP_ABSOLUTE_FILENAME+((index==0)?"":""+index), cv.doubleDirSeparator(absoluteName));
        cv.commonMap.put(AutomatPageDocumentator.TOMAP_FILENAME+((index==0)?"":""+index), (absoluteName.indexOf(File.separator)>=0)?absoluteName.substring(absoluteName.lastIndexOf(File.separator)+1):absoluteName);

        cv.documentFiles++;
    }

}