/*@java
 @Created by Dmitriy I. Suyasov
 @Date 18.03.2005
 @Time 16:56:18
 */
package dsuyasov.inetDoc.functionality;

import dsuyasov.inetDoc.main.InetDocConstant;
import dsuyasov.inetDoc.main.InetDocErrorConstant;

import java.io.*;
import java.util.logging.Logger;
import java.text.MessageFormat;


public class Log {

    /*@
            Log
     */
    private static Log logger;

    /*@
          
     */
    public String buffer = "";

    /*@
           .
         @return    Log
     */
    public static Log getLogger() {
        if (logger == null)
            logger = new Log();
        return logger;
    }

    private LogScope logScope;

    /*@
        .
    */
    private Log() {
//        newLog();
        logScope = new LogScope();
    }

    /*@
            .
     */
    public void newLog() {
        File file = new File(CommonVariables.getInstance().getLogFileName());
        try {
            if (file.exists())
                file.delete();
            file.createNewFile();
        } catch (Exception ioe) {
        }
    }

    /*@
            .
         @param message 
     */
    private synchronized void logtofile(String message) {
        FileOutputStream fos = null;
        try {
             fos = new FileOutputStream(CommonVariables.getInstance().getLogFileName(), true);
        } catch (FileNotFoundException fnfe) {
            File file = new File(CommonVariables.getInstance().getLogFileName());
            try {
                file.createNewFile();
                fos = new FileOutputStream(CommonVariables.getInstance().getLogFileName(), true);
            } catch (Exception ioe) {
                out("     : "+ioe.getMessage());
            }
        } finally {
            try {
                fos.write(message.getBytes());
                fos.close();
            } catch (Exception e) {
                out("     : "+e.getMessage());
            }
        }
    }

    /*@
            .
         @param message 
     */
    private void logtoscreen(String message) {
        System.out.print(message);
    }

    /*@
            .
         @param message 
     */
    public void out(String message) {
        logtoscreen(message);
    }

    /*@
            .
         @param message 
     */
    public void fileOut(String message) {
        logtofile(message);
    }

    /*@
               .
         @param message 
     */
    public void info(String message) {
        CommonVariables cv = CommonVariables.getInstance();
        if (cv.isLogToFile())
            logtofile(message);
        if (cv.isLogToScreen())
            logtoscreen(message);
    }

    /*@
           .
         @param message 
     */
    public void error(String message) {
        message = "     .\n  :\n" + message;
        CommonVariables cv = CommonVariables.getInstance();
        if (cv.isLogToFile())
            logtofile(message);
        logtoscreen(message);
    }

    /*@
           .
         @param message 
     */
    public void event(String automatName, int number) {
        CommonVariables cv = CommonVariables.getInstance();
        if (cv.isLogToFile() || cv.isLogToScreen()) logScope.addEvent(automatName, number);
    }

    /*@
           .
        @param message 
    */
    public void inputVariable(String automatName, int number, boolean result) {
        CommonVariables cv = CommonVariables.getInstance();
        if (cv.isLogToFile() || cv.isLogToScreen()) logScope.addInput(automatName, number, result);
    }

    /*@
            .
         @param message 
     */
    public void output(String automatName, int number) {
        CommonVariables cv = CommonVariables.getInstance();
        if (cv.isLogToFile() || cv.isLogToScreen()) logScope.addOutput(automatName, number);
    }

    /*@
            .
         @param message 
     */
    public void automatChangeState(String automatName, int stateFrom, int stateTo) {
        CommonVariables cv = CommonVariables.getInstance();
        if (cv.isLogToFile() || cv.isLogToScreen()) logScope.addAutomatChangeState(automatName, stateFrom, stateTo);
    }

    /*@
              .
         @param message 
         @param start    
     */
    public void addAutomatStartWork(String automatName, int state) {
        CommonVariables cv = CommonVariables.getInstance();
        if (cv.isLogToFile() || cv.isLogToScreen()) logScope.addAutomatStartWork(automatName, state);
    }

    public void addAutomatFinishWork(String automatName, int state) {
        CommonVariables cv = CommonVariables.getInstance();
        if (cv.isLogToFile() || cv.isLogToScreen()) logScope.addAutomatFinishWork(automatName, state);
    }

    /*@
             .
        @param message 
    */
    public void automat(String automatName, boolean start) {
        CommonVariables cv = CommonVariables.getInstance();
        if (cv.isLogToFile() || cv.isLogToScreen()) logScope.addAutomatWork(automatName, start);
    }

    public void saveTheRule(String ruleName, boolean start, String input, String regularExpression) {
        logScope.addSuccessedRule(ruleName, start, input, regularExpression);
    }

    public void logOutAllMessages() {
        newLog();
        CommonVariables cv = CommonVariables.getInstance();
        if (cv.isLogToFile()) {
            FileOutputStream fos = null;
            try {
                 fos = new FileOutputStream(CommonVariables.getInstance().getLogFileName(), true);
            } catch (FileNotFoundException fnfe) {
                File file = new File(CommonVariables.getInstance().getLogFileName());
                try {
                    file.createNewFile();
                    fos = new FileOutputStream(CommonVariables.getInstance().getLogFileName(), true);
                } catch (Exception ioe) {
                    out("     : "+ioe.getMessage());
                }
            } finally {
                try {
                    String message = "!   \n";
                    fos.write(message.getBytes());
                    if (cv.isLogToScreen())
                        logtoscreen(message);
                    for (int iLoop = 0; iLoop < logScope.size(); iLoop++) {
                        message = logScope.getMessage(iLoop)+"\n";
                        fos.write(message.getBytes());
                        if (cv.isLogToScreen())
                            logtoscreen(message);
                    }
                    message = "!   \n";
                    fos.write(message.getBytes());
                    if (cv.isLogToScreen())
                        logtoscreen(message);
                    fos.close();
                } catch (Exception e) {
                    out("     : "+e.getMessage());
                }
            }
        } else if (cv.isLogToScreen()) {
            logtoscreen("!   \n");
            for (int iLoop = 0; iLoop < logScope.size(); iLoop++) {
                logtoscreen(logScope.getMessage(iLoop)+"\n");
            }
            logtoscreen("!   \n");
        }

        if ((cv.getRulesLogFile() != null) && (cv.getRulesLogFile().length() > 0)) {
            String fileName = CommonVariables.getInstance().getRulesLogFile();
            String tmpStr = fileName;
            String directoryName = "";
            while (tmpStr.indexOf(File.separator) >= 0) {
                directoryName += (directoryName.length()>0)?File.separator:"";
                directoryName += tmpStr.substring(0, tmpStr.indexOf(File.separator));
                tmpStr = tmpStr.substring(tmpStr.indexOf(File.separator) + File.separator.length());
                File dir = new File(directoryName);
                dir.mkdir();
            }

            File file = new File(fileName);

            try {
                file.createNewFile();
                FileWriter fw = new FileWriter(file);
                for (int iLoop = 0; iLoop < logScope.getRuleSize(); iLoop++)
                    fw.write(logScope.getRuleMessage(iLoop));
                fw.close();
            } catch (IOException ioe) {
                logtoscreen("     ");
            }

        }
    }

}
