/**
 @author Dmitriy I. Suyasov
 */
package dsuyasov.inetDoc.rulesZone;

import java.util.Iterator;
import java.util.ArrayList;

public class Rules extends Rule {

    private ArrayList links = new ArrayList();

    public Rules(int next, int number) throws RuleException {
        super(new ArrayList(), next, number);
    }

    public void addRule(Rule rule) {
        ArrayList list = (ArrayList) object;
        list.add(rule);
    }

    public Rule getLastRule() {
        ArrayList list = (ArrayList) object;
        return ((list == null || list.isEmpty()) ? null : (Rule) list.get(list.size() - 1) );
    }

    public void setLastAsStartNumber() throws RuleException {
        ArrayList list = (ArrayList) object;
        if (list == null || list.isEmpty())
            throw new RuleException("  :         .");
        links.add(new Integer(list.size() - 1));
    }

    public boolean proceed(ForwardElement element) {
        increaseTheCounter();
//        results.clear();
//        if (this.start.intValue() == 0)
//            results.add(new ForwardElement(nextStep.getNext(), element.getText(), element.getResult()));
        ArrayList list = new ArrayList();
        for (Iterator iter = links.iterator(); iter.hasNext(); )
            list.add(new ForwardElement(((Integer) iter.next()).intValue() + 1, element.getText(), element.getResult(), element.getHistory()));
        ArrayList listOfNext = new ArrayList();
        ArrayList col = (ArrayList) object;
        fillZeroTheCounters();

        while (!listHasZeroOnly(list) && !list.isEmpty()) {
            for (Iterator iter = list.iterator(); iter.hasNext(); ) {
                ForwardElement forward = (ForwardElement) iter.next();
                int nextElement = forward.getNext() - 1;
                if (nextElement < 0) {
                    listOfNext.add(forward);
                } else {
                    Rule rule = (Rule) col.get(nextElement);
                    rule.proceed(forward);
                    listOfNext.addAll(new ArrayList(rule.results));
                }
            }
            list = listOfNext;
            listOfNext = new ArrayList();
        }

        if (list.isEmpty()) {
            results.clear();
            if (this.start.intValue() == 0)
                results.add(new ForwardElement(nextStep.getNext(), element.getText(), element.getResult(), element.getHistory()));
            return false;
        }

        results.clear();
        if (!counterMore())
            for (Iterator iter = list.iterator(); iter.hasNext(); ) {
                ForwardElement forwardElement = (ForwardElement) iter.next();
                results.add(new ForwardElement(getRuleNumber(), forwardElement.getText(), forwardElement.getResult(), forwardElement.getHistory()));
            }
        if (!counterLess())
            for (Iterator iter = list.iterator(); iter.hasNext(); ) {
                ForwardElement forwardElement = (ForwardElement) iter.next();
                results.add(new ForwardElement(nextStep.getNext(), forwardElement.getText(), forwardElement.getResult(), forwardElement.getHistory()));
            }
        if (this.start.intValue() == 0)
            results.add(new ForwardElement(nextStep.getNext(), element.getText(), element.getResult(), element.getHistory()));
        return true;
    }

    private void fillZeroTheCounters() {
        for (Iterator iter = ((ArrayList) object).iterator(); iter.hasNext(); ) {
            Rule rule = (Rule) iter.next();
            rule.fillZeroTheCounter();
        }
    }

    private boolean listHasZeroOnly(ArrayList list) {
        for (int iLoop = 0; iLoop < list.size(); iLoop++)
            if (((ForwardElement) list.get(iLoop)).getNext() != 0)
                return false;
        return true;
    }

    public int getLastLink() {
        int size = ((ArrayList) object).size();
        if ((links.size() > 0) && (size - 1 == ((Integer) links.get(links.size() - 1)).intValue()))
            return 0;
        else
            return size;
    }

    public int size() {
        return ((ArrayList) object).size();
    }

    public String toString() {
        String str = "{";
        ArrayList list = (ArrayList) object;
        for (Iterator iter = list.iterator(); iter.hasNext(); ) {
            Rule rule = (Rule) iter.next();
            str += rule.toString() + (iter.hasNext()?", ":"");
        }
        str += "}";
        return str;
    }

}
