/**
 @author Dmitriy I. Suyasov
 @since 19.08.2005 13:55:58
 */
package dsuyasov.inetDoc.rulesZone;

import java.util.ArrayList;

public class RuleString extends Rule {

    public RuleString(String string, int next, int number) throws RuleException {
        super(string, next, number);
        if (string.length() == 0)
            throw new RuleException("  :  ["+string+"] ");
        char ch = string.charAt(string.length()-1);
        if (ch=='\\')
            throw new RuleException("  :  ["+string+"]     [\\]");
    }

    public boolean proceed(ForwardElement element) {
        increaseTheCounter();
        results.clear();
        String input = element.getText();
        if (this.start.intValue() == 0)
            results.add(new ForwardElement(nextStep.getNext(), input, element.getResult(), element.getHistory()));
        String string = (String) object;
        boolean result = !((input.length() < string.length()) || (input.lastIndexOf(string) != input.length() - string.length()));
        if (result) {
            results.clear();
            ArrayList list = new ArrayList();
            if (!counterMore())
                list.add(new ForwardElement(getRuleNumber(), input.substring(0, input.length() - string.length()), element.getResult(), element.addToHistory(new Object[] {new Integer(Rule.STRING), object, element.getText()})));
            if (!counterLess())
                list.add(new ForwardElement(nextStep.getNext(), input.substring(0, input.length() - string.length()), element.getResult(), element.addToHistory(new Object[] {new Integer(Rule.STRING), object, element.getText()})));
            results.addAll(list);
            if (this.start.intValue() == 0)
                results.add(new ForwardElement(nextStep.getNext(), input, element.getResult(), element.getHistory()));
        }

        return result;
    }

    public String getStartPoint() {
        return null;
    }

    public String toString() {
        return "{ STRING ["+object+"]}";
    }

}
