/*@java
 @Created by Dmitriy I. Suyasov
 @Date 08.04.2005
 @Time 14:04:51
 */
package dsuyasov.inetDoc.functionality;

import org.w3c.dom.Node;

import java.util.ArrayList;
import java.util.Collection;

public class Entity {

    /*@
             
    */
    public static final int DEFAULT_ATTRIBUTE = 0;

    /*@
           
     */
    private String entityName;
    /*@
             
     */
    private ArrayList attributes;
    /*@
          - 
     */
    private Collection templateFiles;

    private RulesStarter rulesStarter;

    public static final String NAME_ATTRIBUTE = "name";
    public static final String HREF_ATTRIBUTE = "href";

    public static final String ATTRIBUTE_NODE_NAME = "attribute";
    public static final String DEFAULT_ATTRIBUTE_NODE_NAME = "defaultattribute";
    public static final String TEMPLATE_FILE_NODE_NAME = "template-file";

    /*@
        .
        @param xml  - XML-
        @param node  XML-   
    */
    public Entity(Node node) throws XMLProcessorException {

        try {
            entityName = XMLProcessor.getNodeAttribute(node, NAME_ATTRIBUTE);
        } catch (XMLProcessorException e) {
            entityName = "";
        }
        String defaultAttribute = XMLProcessor.getNodeAttribute(XMLProcessor.getNode(node, DEFAULT_ATTRIBUTE_NODE_NAME), NAME_ATTRIBUTE);
        attributes = new ArrayList(XMLProcessor.getNodesAttribute(XMLProcessor.getNodes(node, ATTRIBUTE_NODE_NAME), NAME_ATTRIBUTE));
        for (int iLoop = 0; iLoop < attributes.size(); iLoop++) {
            String attribute = (String) attributes.get(iLoop);
            if (attribute.equals(defaultAttribute) && (iLoop > 0)) {
                attributes.set(0, attributes.set(iLoop, attributes.get(0)));
                break;
            }
        }

        templateFiles = XMLProcessor.getNodesAttribute(XMLProcessor.getNodes(node, TEMPLATE_FILE_NODE_NAME), HREF_ATTRIBUTE);
        if (entityName.length()==0)
            return;
        Node ruleNode = XMLProcessor.getNode(node, Template.RULES_NODE_NAME);
        try {
            rulesStarter = new RulesStarter(ruleNode, null);
         } catch (Exception e) {
            throw new XMLProcessorException(e.getMessage());
        }
    }

    /*@
             
         @param name  
         @return    
     */
    public boolean hasAttribute(String name) {
        for (int iLoop = 0; iLoop < attributes.size(); iLoop++)
            if (attributes.get(iLoop).equals(name))
                return true;
        return false;
    }

    public RulesStarter getRulesStarter() {
        return rulesStarter;
    }

    public Collection getTemplateFiles() {
        return templateFiles;
    }

    public String getName() {
        return entityName;
    }

    public ArrayList getAttributes() {
        return attributes;
    }

}