/*@java
 @Created by Dmitriy I. Suyasov
 @Date 07.04.2005
 @Time 13:57:13
 */
package dsuyasov.inetDoc.functionality;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Collection;


public class Template {

    /*@
          -  
    */
    public static final String NODE_START = "start";
    /*@
          -  
    */
    public static final String NODE_END = "end";

    /*@
            
     */
    public static final int DEFAULT_ENTITY = 0;

    /*@
           ,     
     */
    private ArrayList types;
    /*@
          
     */
    private ArrayList entities;

    private String templateFileName = "";

    private RulesStarter rulesStarter;

    public static final String ENTITY_NODE_NAME = "entity";
    public static final String DEFAULT_ENTITY_NODE_NAME = "defaultentity";
    public static final String TEMPLATE_FILE_NODE_NAME = "template-file";

    public static final String NAME_ATTRIBUTE = "name";
    public static final String RULES_NODE_NAME = "rules";
    public static final String HREF_ATTRIBUTE = "href";

    /*@
        .
        @param types   ,     
        @param templateFileName    
    */
    public Template(ArrayList types, String templateFileName) throws Exception {

        this.types = types;

        DocumentBuilder db =  DocumentBuilderFactory.newInstance().newDocumentBuilder();
        Document doc = db.parse(templateFileName);

        Node mainNode = XMLProcessor.getNode(doc, "template");
        entities = new ArrayList();
        String defaultEntity = XMLProcessor.getNodeAttribute(XMLProcessor.getNode(mainNode, DEFAULT_ENTITY_NODE_NAME), NAME_ATTRIBUTE);
        Collection entityNodes = XMLProcessor.getNodes(mainNode, ENTITY_NODE_NAME);
        for (Iterator iter = entityNodes.iterator(); iter.hasNext(); ) {
           Entity entity = new Entity((Node) iter.next());
           if (entity.getName().equals(defaultEntity))
               entities.add(DEFAULT_ENTITY, entity);
           else
               entities.add(entity);
        }
        Node ruleNode = XMLProcessor.getNode(mainNode, RULES_NODE_NAME);
        this.templateFileName = XMLProcessor.getNodeAttribute(XMLProcessor.getNode(mainNode, TEMPLATE_FILE_NODE_NAME), HREF_ATTRIBUTE);
        rulesStarter = new RulesStarter(ruleNode, null);
    }

    /*@
             
        @param name  
        @return  
    */
    public ArrayList getRules(String name) {
        ArrayList rules = rulesStarter.rules;
        Iterator iter = rules.iterator();
        ArrayList entitiesRule = new ArrayList();
        while (iter.hasNext())
            entitiesRule.addAll(((RuleStarter) iter.next()).getRule(name));
        return entitiesRule;
    }

    /*@
               
         @param name  
         @return 
     */
    public RuleStarter getFirstRule(String name) {
        final int FIRST = 0;
        Iterator iter = rulesStarter.rules.iterator();
        ArrayList entitiesRule = new ArrayList();
        while (iter.hasNext() && (entitiesRule.size()==0))
            entitiesRule.addAll(((RuleStarter) iter.next()).getRule(name));
        if (entitiesRule.size()==0)
            return null;
        return (RuleStarter) entitiesRule.get(FIRST);
    }

    /*@
             
         @param name  
         @return 
     */
    public Entity getEntity(String name) {
        for (int iLoop = 0; iLoop < entities.size(); iLoop++)
            if (((Entity)entities.get(iLoop)).getName().equals(name))
                return (Entity) entities.get(iLoop);
        return null;
    }

    public RulesStarter getRulesStarter() {
        return rulesStarter;
    }

    public Entity getDefaultEntity() {
        return (Entity) entities.get(DEFAULT_ENTITY);
    }

    public String getTemplateFileName() {
        return templateFileName;
    }

    public ArrayList getTypes() {
        return types;
    }

}