/**
 @author Dmitriy Suyasov
 @since 10.10.2005 13:55:43
 */
package dsuyasov.inetDoc.aho;

import dsuyasov.inetDoc.automat.Automat;

import java.util.ArrayList;

public class AutomatInfoFinderByAho extends Automat {

    private ArrayList transitions;
    private int start, end;
    private String str;

    private States states;

    public AutomatInfoFinderByAho(ArrayList transitions, int start, int end) {
        super("dsuyasov.inetDoc.aho.AutomatInfoFinderByAho");
        this.start = start;
        this.end = end;
        this.transitions = transitions;
    }

    public void startAutomat(String inputString) {
        str = inputString;
        states = new States();
        states.add(new State(start, 0));
        work();
    }

    /*@
          
    */
    protected void initialize() {}

    /*@
          
        @param event   
    */
    protected void automat(int event) {
        States newStates = new States();
        for (int iLoop = 0; iLoop < states.size(); iLoop++) {
            State state = states.get(iLoop);
            for (int iLoop2 = 0; iLoop2 < transitions.size(); iLoop2++) {
                Transition transition = (Transition) transitions.get(iLoop2);
                if (transition.getStartState() == state.getState()) {
                    String condition = transition.getCondition();
                    if (condition.length() == 0) {
                        newStates.add(new State(transition.getNextState(), state.getPosition()));
                    } else if (condition.equals(".") && (str.charAt(state.getPosition()) != '\n')) {
                        newStates.add(new State(transition.getNextState(), state.getPosition() + 1));
                    } else if (condition.charAt(0) == '\\') {
                        //todo
                    }
                }
            }
        }
    }



}
