/*@java
 @Created by Dmitriy I. Suyasov
 @Date 07.04.2005
 @Time 12:47:00
 */
package dsuyasov.inetDoc.functionality;

import java.util.ArrayList;
import java.io.File;

public class CommonVariables {

    /*@
            
     */
    public static String LOG_FILE_NAME = "log.txt";
    /*@
            
     */
    public static String PROPERTY_FILE_NAME = "inetdoc.xml";
    /*@
             
     */
    public static String DESTINATION_DIRECTORY = "documentation";


    /*@
          CommonVariables
    */
    private static CommonVariables cv;

    /*@
             
        @return  
     */
    public static CommonVariables getInstance() {
        if (cv == null)
            cv = new CommonVariables();
        return cv;
    }


    /*@
       .
    */
    private CommonVariables() {
        sourceDirectory = "";
        currentDocFile = new ArrayList();
        templates = new ArrayList();
        files = new ArrayList();
        commonFiles = new ArrayList();
        defaultTemplate = "";
        logToFile = false;
        logToScreen = false;
        logFileName = LOG_FILE_NAME;
        propertyFileName = PROPERTY_FILE_NAME;
        destinationDirectory = DESTINATION_DIRECTORY;
        pageDepository = new PageDepository();
        rulesLogFile = null;
    }

/*@
     
*/
//    public ArrayList errors;

/*@
       
*/
    private String sourceDirectory;

    public String getRulesLogFile() {
        return rulesLogFile;
    }

    public void setRulesLogFile(String rulesLogFile) {
        File file = new File(rulesLogFile);
        this.rulesLogFile = file.getAbsolutePath();
    }

    private String rulesLogFile;

/*@
       
*/
    private ArrayList templates;

/*@
      
*/
    private ArrayList files;

    /*@
            
    */
    public boolean logToFile;
    /*@
            
    */
    public boolean logToScreen;

    public String logFileName;

    public String propertyFileName;

    public String destinationDirectory;

    public PageDepository pageDepository;
//    public String doubleDirSeparator(String src) {
//        int index;
//        int res = src.indexOf("\\");
//        while (res>=0) {
//            src = ((res>0)?src.substring(0,res):"") + "\\" + ((res<src.length())?src.substring(res):"");
//            index = res + 2;
//            res = src.indexOf("\\", index);
//        }
//        return src;
//    }

/*@
     ,  
*/
//private int documentFiles;

/*@
          
*/
    private ArrayList currentDocFile;// = new Stack();

/*@
      
*/
    private ArrayList commonFiles;

/*@
     ,      
*/
//public Map commonMap = new HashMap();
/*@
        
*/
    private String defaultTemplate;

    public String getSourceDirectory() {
        return sourceDirectory;
    }

    public void setSourceDirectory(String sourceDirectory) throws RuntimeException {
        File file = new File(sourceDirectory);
        if (!file.exists())
            throw new RuntimeException("     ["+sourceDirectory+"]  ");
        this.sourceDirectory = file.getAbsolutePath();
    }

    public ArrayList getTemplates() {
        return templates;
    }

    public void setTemplates(ArrayList templates) {
        this.templates = templates;
    }

    public ArrayList getFiles() {
        return files;
    }

    public void setFiles(ArrayList files) {
        this.files = files;
    }

    public ArrayList getCurrentDocFile() {
        return currentDocFile;
    }

    public void setCurrentDocFile(ArrayList currentDocFile) {
        this.currentDocFile = currentDocFile;
    }

    public ArrayList getCommonFiles() {
        return commonFiles;
    }

    public void setCommonFiles(ArrayList commonFiles) {
        this.commonFiles = commonFiles;
    }

    public String getDefaultTemplate() {
        return defaultTemplate;
    }

    public void setDefaultTemplate(String defaultTemplate) {
        this.defaultTemplate = defaultTemplate;
    }

    public boolean isLogToFile() {
        return logToFile;
    }

    public void setLogToFile(boolean logToFile) {
        this.logToFile = logToFile;
    }

    public boolean isLogToScreen() {
        return logToScreen;
    }

    public void setLogToScreen(boolean logToScreen) {
        this.logToScreen = logToScreen;
    }

    public String getLogFileName() {
        return logFileName;
    }

    public void setLogFileName(String logFileName) {
        this.logFileName = logFileName;
    }

    public String getPropertyFileName() {
        return propertyFileName;
    }

    public void setPropertyFileName(String propertyFileName) {
        File file = new File(propertyFileName);
        if (!file.exists() || !file.isFile())
            throw new RuntimeException("   ["+propertyFileName+"]  ");
        this.propertyFileName = propertyFileName;
    }

    public String getDestinationDirectory() {
        return destinationDirectory;
    }

    public void setDestinationDirectory(String destinationDirectory) {
        this.destinationDirectory = destinationDirectory;
    }

    public void saveToPageDepository(Page page) {
        pageDepository.addPage(page);
    }

    public PageDepository getPageDepository() {
        return pageDepository;
    }

    /*@
           
       @param al   
       @param path ,     
    */
    public void getAllFiles(ArrayList al, String path) throws Exception{
        File file = new File(path);
        if (file.isFile()) {
            al.add(file.getAbsolutePath());
            return;
        }
        String[] list = file.list();
        for (int iLoop = 0; iLoop < list.length; iLoop++)
            try {
                getAllFiles(al, file.getAbsolutePath()+File.separator+list[iLoop]);
            } catch (Exception e) {
                throw new Exception(e.getMessage());
            }
    }

    public Template getTemplateByExtension(String pageFileName) {
        for (int iLoop = 0; iLoop < getTemplates().size(); iLoop++) {
           ArrayList types = ((Template) getTemplates().get(iLoop)).getTypes();
           for (int iLoop2 = 0; iLoop2 < types.size(); iLoop2++)
               if (pageFileName.lastIndexOf((String) types.get(iLoop2)) == pageFileName.length() - ((String) types.get(iLoop2)).length())
                   return (Template) getTemplates().get(iLoop);
        }
        return null;
    }

    public boolean compareIds(ArrayList first, ArrayList second) {
        if ((first == null) || (second == null))
            return false;
        if (first.size() != second.size())
            return false;
        for (int iLoop = 0; iLoop < first.size(); iLoop++)
            if (((Byte) first.get(iLoop)).byteValue() != ((Byte) second.get(iLoop)).byteValue())
                return false;
        return true;
    }
}
