/*@java
 @Created by Dmitriy I. Suyasov
 @Date 10.04.2005
 @Time 15:27:24
 */
package dsuyasov.inetDoc.functionality;

import dsuyasov.inetDoc.automat.AutomatSintaxRuleAnalyser;
import dsuyasov.inetDoc.rulesZone.Rule;

import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;


public class Page {

    public static final String REPEAT_INDEX = "REPEAT_INDEX";

    public Page() {
        blocs = new ArrayList();
        associatedNames = new HashMap();
    }

    public Page(Page page) {
        blocs = new ArrayList();
        for (Iterator iter = page.blocs.iterator(); iter.hasNext(); ) blocs.add(new Bloc((Bloc)iter.next()));
        associatedNames = new HashMap(page.associatedNames);
        defaultBloc = page.defaultBloc;
    }

    /*@
          .
    */
    private ArrayList blocs;
    private Map associatedNames;
    private int defaultBloc = 0;

    public void addBloc(Bloc bloc) {
        blocs.add(bloc);
        associatedNames.put("bloc" + (blocs.size()-1), new Integer(blocs.size()-1));
    }

    public int getIndexOfBlocWithName(String name) {
        for (int iLoop = 0; iLoop < blocs.size(); iLoop++) {
            Bloc bloc = (Bloc) blocs.get(iLoop);
            if (bloc.getEntity().getName().equals(name))
                return iLoop;
        }
        return 0;
    }

    public Bloc getBloc(int index) {
        return (Bloc) blocs.get(index);
    }

    public int blocSize() {
        return blocs.size();
    }

    public Bloc getLastBloc() {
        return (blocs.size() == 0)? null : ((Bloc) blocs.get(blocs.size() - 1));
    }

    /*@
          ID   
        @return ID 
    */
//    public int getNewId() {
//        int newId = 0;
//        for (int iLoop = 0; iLoop < blocs.size(); iLoop++)
//            if (((Bloc) blocs.get(iLoop)).blocId > newId)
//                newId = ((Bloc) blocs.get(iLoop)).blocId + 1;
//        return newId;
//    }

    public Bloc getName(String name) {
        String postfix = ("0123456789".indexOf(name.charAt(name.length() - 1))>=0)?"":"0";
        return (Bloc) blocs.get(((Integer) associatedNames.get(name+postfix)).intValue());
    }

    public void setDefault(int index) {
        defaultBloc = index;
    }

    public Page setDefaultBloc(int index) {
        defaultBloc = index;
        return this;
    }

    public void setDefault(String name) {
        String postfix = ("0123456789".indexOf(name.charAt(name.length() - 1))>=0)?"":"0";
        defaultBloc = ((Integer) associatedNames.get(name+postfix)).intValue();
    }

    public int getDefault() {
        return defaultBloc;
    }

    public String getElement(String name, String property, String var) throws RuntimeException {
        name = getPropertiesFromString(name);
        var = getPropertiesFromString(var);
        property = getPropertiesFromString(property);
        if (property == null)
            throw new RuntimeException(" [property]    ");
        if (name == null) {
            if (var == null)
                return getElement(property);
            else {
                String element = getElement(property);
                getBloc(defaultBloc).setVar(var, element);
                return element;
            }
        } else if (var == null) {
            return getElement(name, property);
        } else {
            String element = getElement(name, property);
            getBloc(defaultBloc).setVar(var, element);
            return element;
        }
    }

    private String getElement(String name, String property) throws RuntimeException {
        Bloc bloc = getName(name);
        String element = bloc.getVar(property);
        if (element == null)
            element = bloc.getProperty(property);
        if (element == null)
            throw new RuntimeException("    ["+property+"]     ["+name+"]");
        return element;
    }

    private String getElement(String property) throws RuntimeException {
        Bloc bloc = getBloc(defaultBloc);
        String element = bloc.getVar(property);
        if (element == null)
            element = bloc.getProperty(property);
        if (element == null)
            throw new RuntimeException("    ["+property+"]    ");
        return element;
    }

    public ArrayList getRepeatPages(String name, String property, String var, String times) throws RuntimeException {
        name = getPropertiesFromString(name);
        var = getPropertiesFromString(var);
        property = getPropertiesFromString(property);
        times = getPropertiesFromString(times);
        int number = 0;
        try {
            if (times != null) {
                number = Integer.parseInt(times);
                if (number <=0)
                    throw new Exception();
            }
        } catch (Exception e) {
            throw new RuntimeException(" [times]  [replace]     ,   ["+times+"]");
        }
        ArrayList list = new ArrayList();
        if (property != null) {
            if (var == null)
                throw new RuntimeException(" [repeat]    [property]    [var]");
            Bloc bloc;
            if (name == null) {
                bloc = getBloc(defaultBloc);
            } else {
                bloc = getName(name);
            }
            if (bloc == null)
                throw new RuntimeException("     "+((name==null)?" ":"["+name+"]"));
            ArrayList properties;
            int inc = 0;
            if (bloc.getVar(property+inc)==null)
                properties = bloc.getAttributes(property);
            else {
                properties = new ArrayList();
                while (bloc.getVar(property+inc) != null) {
                    properties.add(bloc.getVar(property+inc));
                    inc++;
                }
            }
            if (properties.size() == 0)
                throw new RuntimeException("     ["+property+"]");
            int index = 0;
            for (Iterator iter = properties.iterator(); iter.hasNext(); ) {
                Page newPage = new Page(this);
                //int postfix = 0;
                //while (newPage.getBloc(newPage.getDefault()).getVar(REPEAT_INDEX+postfix)!=null) postfix++;
                newPage.getBloc(newPage.defaultBloc).setVar(var, (String)iter.next());
                //newPage.getBloc(newPage.defaultBloc).setVar(REPEAT_INDEX+postfix, ""+index);
                list.add(newPage);
                index++;
                if ((times!=null) && (number<=index))
                    break;
            }
        } else {
            if (name == null) {
                if (var != null)
                    throw new RuntimeException(" [repeat]    [property]  [name]     [var]");
                if (times == null)
                    for (int iLoop = 0; iLoop < blocs.size(); iLoop++) {
                        Page newPage = new Page(this);
                        //int postfix = 0;
                        //while (newPage.getBloc(newPage.getDefault()).getVar(REPEAT_INDEX+postfix)!=null) postfix++;
                        newPage.setDefault(iLoop);
                        //newPage.getBloc(iLoop).setVar(REPEAT_INDEX+postfix, ""+iLoop);
                        list.add(newPage);
                    }
                else
                    for (int iLoop = 0; iLoop < number; iLoop++) {
                        Page newPage = new Page(this);
                        //int postfix = 0;
                        //while (newPage.getBloc(newPage.getDefault()).getVar(REPEAT_INDEX+postfix)!=null) postfix++;
                        //newPage.getBloc(newPage.getDefault()).setVar(REPEAT_INDEX+postfix, ""+iLoop);
                        list.add(newPage);
                    }
            } else {
                if (var == null)
                    throw new RuntimeException(" [repeat]    [name]    [var]");
                Bloc bloc = getName(name);
                int index = 0;
                for (Iterator iter = bloc.getAllAttributes().iterator(); iter.hasNext(); ) {
                    Page newPage = new Page(this);
                    //int postfix = 0;
                    //while (newPage.getBloc(newPage.getDefault()).getVar(REPEAT_INDEX+postfix)!=null) postfix++;
                    newPage.getBloc(newPage.defaultBloc).setVar(var, (String) iter.next());
                    //newPage.getBloc(newPage.defaultBloc).setVar(REPEAT_INDEX+postfix, ""+index);
                    list.add(newPage);
                    index++;
                    if ((times != null) && (number <= index))
                        break;
                }
            }
        }
        return list;
    }

    public void replace(String name, String property, String replaceWhat, String replaceTo, String var, String times, String notReturn) throws RuntimeException {
        name = getPropertiesFromString(name);
        var = getPropertiesFromString(var);
        property = getPropertiesFromString(property);
        times = getPropertiesFromString(times);
        replaceWhat = getPropertiesFromString(replaceWhat);
        replaceTo = getPropertiesFromString(replaceTo);
        if (times == null)
            replacement(null, name, property, replaceWhat, replaceTo, var, notReturn);
        else {
            int number;
            try {
                number = Integer.parseInt(times);
                if (number <=0)
                    throw new Exception();
            } catch (Exception e) {
                throw new RuntimeException(" [times]  [replace]     ");
            }
            replacement(new Integer(number), name, property, replaceWhat, replaceTo, var, notReturn);
        }
    }

    public void replaceOnce(String name, String property, String replaceWhat, String replaceTo, String var, String notReturn) throws RuntimeException {
        name = getPropertiesFromString(name);
        var = getPropertiesFromString(var);
        property = getPropertiesFromString(property);
        replaceWhat = getPropertiesFromString(replaceWhat);
        replaceTo = getPropertiesFromString(replaceTo);
        replacement(new Integer(1), name, property, replaceWhat, replaceTo, var, notReturn);
    }

    private void replacement(Integer times, String name, String property, String replaceWhat, String replaceTo, String var, String notReturn) throws RuntimeException {
        if ((replaceWhat == null) || (replaceTo == null) || (var == null))
            throw new RuntimeException(" [replace]/[replaceOnce]    [property], [replacewhat], [replaceto], [var]");

        String attribute = getAttribute(name, property);

        AutomatSintaxRuleAnalyser asra = new AutomatSintaxRuleAnalyser();
        asra.startAutomat(replaceWhat, false);
        if (asra.ERROR.length() > 0)
            throw new RuntimeException(asra.ERROR+".   ["+replaceWhat+"] ");
        Rule rule = (Rule) asra.ruleBuilder.getResult();
        int counter = 0;
        int timeCounter = 0;
        int index = 0;
        int border = attribute.length() * 10;
        border = (border < 100)?100:border;
        while ((counter < border) && (index < attribute.length())) {
            counter++;
            index++;
            if (rule.proceed(attribute.substring(0, index))) {
                attribute = rule.getResult() + replaceTo + attribute.substring(index);
                timeCounter++;
                if ((times != null) && (times.intValue() == timeCounter)) {
                    getBloc(defaultBloc).setVar(var, attribute);
                    return;
                }
                if (notReturn == null)
                    index = rule.getResult().length();
                else if (notReturn.equals("true"))
                    index = (rule.getResult() + replaceTo).length();
                else
                    index = rule.getResult().length();
            }
        }
        if (counter == border)
            throw new RuntimeException(" [replace]   [name = "+name+", property = "+property+", replacewhat = "+replaceWhat+", replaceto = "+replaceTo+", var = "+var+", NOTRETURN = "+notReturn+"]  !");
        getBloc(defaultBloc).setVar(var, attribute);
    }

    public boolean match(String name, String property, String expression) throws RuntimeException {
        name = getPropertiesFromString(name);
        expression = getPropertiesFromString(expression);
        property = getPropertiesFromString(property);
        if (expression == null)
            throw new RuntimeException(" [match]    [expression]");

        String attribute = getAttribute(name, property);

        AutomatSintaxRuleAnalyser asra = new AutomatSintaxRuleAnalyser();
        asra.startAutomat(expression, false);
        if (asra.ERROR.length() > 0)
            throw new RuntimeException(asra.ERROR+".   ["+expression+"] ");
        Rule rule = (Rule) asra.ruleBuilder.getResult();
        if (rule.proceed(attribute)) {
            ArrayList list = rule.getResults();
            for (Iterator iter = list.iterator(); iter.hasNext(); )
                if (((String) iter.next()).length() == 0)
                    return true;
        }
        return false;
    }

    public boolean notMatch(String name, String property, String expression) throws RuntimeException {
        name = getPropertiesFromString(name);
        expression = getPropertiesFromString(expression);
        property = getPropertiesFromString(property);
        if (expression == null)
            throw new RuntimeException(" [notMatch]    [expression]");

        String attribute = getAttribute(name, property);

        AutomatSintaxRuleAnalyser asra = new AutomatSintaxRuleAnalyser();
        asra.startAutomat(expression, false);
        if (asra.ERROR.length() > 0)
            throw new RuntimeException(asra.ERROR+".   ["+expression+"] ");
        Rule rule = (Rule) asra.ruleBuilder.getResult();
        if (rule.proceed(attribute)) {
            ArrayList list = rule.getResults();
            for (Iterator iter = list.iterator(); iter.hasNext(); )
                if (((String) iter.next()).length() == 0)
                    return false;
        }
        return true;
    }

    public String[] saveExpression(String var, String expression) throws RuntimeException {
        var = getPropertiesFromString(var);
        expression = getPropertiesFromString(expression);
        if ((var == null) || (expression == null))
            throw new RuntimeException(" [save]    [var]  [expression]");
        //getBloc(defaultBloc).setVar(var, expression);
        return new String[] {var, expression};
    }

    public String getAttribute(String name, String property) throws RuntimeException {
        if (property == null)
            throw new RuntimeException("    [property]");

        Bloc bloc;
        if (name == null)
            bloc = getBloc(defaultBloc);
        else
            bloc = getName(name);
        if (bloc == null)
            throw new RuntimeException("     "+((name==null)?" ":"["+name+"]"));
        String attribute = bloc.getVar(property);
        if (attribute == null)
            attribute = bloc.getProperty(property);
        if (attribute == null)
            throw new RuntimeException("    ["+property+"]");
        return attribute;
    }

    public String getPropertiesFromString(String str) throws RuntimeException {
        if (str == null)
            return null;
        int startIndex = str.indexOf("${");
        int counter = 0;
        while ((counter < 100) && (startIndex >= 0)) {
            counter++;
            int endIndex = str.indexOf("}", startIndex);
            if (endIndex < 0)
                throw new RuntimeException(" ["+str+"]    ");
            String substr = str.substring(startIndex+2, endIndex);
            int colon = substr.indexOf(":");
            String attribute;
            if (colon > 0)
                attribute = getAttribute(substr.substring(0, colon), substr.substring(colon + 1));
            else
                attribute = getAttribute(null, substr);
            str = str.substring(0, startIndex) + attribute + str.substring(endIndex + 1);
            startIndex = str.indexOf("${");
        }
        if (counter >= 100)
            throw new RuntimeException("      !");
        return str;
    }

    public static String toStrings() {
        return "!!!";
    }

}
